import mpi.*;

class Wall {
  static public void main(String[] argv) throws MPIException {
    
	for (int i=0; i<argv.length; i++)
      System.out.print(argv[i]+"#");
	System.out.println();
    
	MPI.Init(argv);
	int rank = MPI.COMM_WORLD.Rank();
	int size = MPI.COMM_WORLD.Size();
	
    System.out.println("Java -- Size: "+size+"  rank: "+rank+".");
    char [] buf = new char [200];
    


    if(rank==0)
      MPI.COMM_WORLD.Recv(buf, 0, 200, MPI.CHAR, 1, 10);
    else
      MPI.COMM_WORLD.Send(buf, 0, 200, MPI.CHAR, 0, 10);


    int src = (rank==0) ? size-1 : rank-1;
    int dest = (rank==size-1) ? 0 : rank+1;
    int sendtag = rank;
    int recvtag = src;
    //    MPI.COMM_WORLD.Sendrecv(buf, 0, 200, MPI.CHAR, src, recvtag,
    //                      buf, 0, 200, MPI.CHAR, dest, sendtag);


    
	MPI.Finalize();
  }
}
